/***************************************************************************
 *   Copyright (C) 2008 by Vladimir Kim, Princeton University			   *
 *   Author: Vladimir Kim (kim_vladimir@yahoo.com, vk@princeton.edu)       *
 *   Research Supervisor: Tom Funkhouser (funk@cs.princeton.edu)           *
 *                                  ****                                   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __TIME_PROFILER_H
#define __TIME_PROFILER_H

#include <Qt/qobject.h>

#include <iostream>
#include <vector>
#include <map>
#include <time.h>

//#define CALCULATE_TIMING

class TimeProfiler
{
	public:
		TimeProfiler();
		void startedProcess(QString processID);
		void finishedProcess(QString processID, bool printTime = false);
		long getTotalProcessLengthInCycles(QString processID);
		QString getTotalProcessLengthInSeconds(QString processID);
		int getTotalProcessLengthInSecondsInt(QString processID);	
		QString profile();

#ifdef CALCULATE_TIMING
		static TimeProfiler * m_pGlobalSuperProfiler;
#endif
	
	protected:
		struct Process
		{
			Process();
			long m_iCurrStartTime;
			std::vector<long> m_iRunningTimes;
			long m_iTotalRunningTime;
			QString m_sProcessName;
		};
		std::map<QString, Process> m_mIDToProcessMap;
};

#endif

