//#include "CVLib.h"
//#include "Numerical.h"
//#include "Deformations.h"
//#include "R2Shapes/R2Shapes.h"
//#include "R3Shapes/R3Shapes.h"
//#include "R3Graphics/R3Graphics.h"
//#include <QtOpenGL/QGLContext>
//#include <QtOpenGL/QGLFramebufferObject>
//#include <QtOpenGL/QGLPixelBuffer>
//#include <QtOpenGL/QGLFormat>
//#include <Qt/qimage.h>
//#include <Qt/qfile.h>
//#include <Qt/qtextstream.h>
//#include "PDSampling.h"
//#include "DrawingRoutines.h"
//
//#ifndef __DEFORM_CURVE_H
//#define __DEFORM_CURVE_H
//
///**
// * Deforming 2D curve
// */
//class DeformCurve : public DeformationModel
//{
//	public:
//		enum IntegrationApproximationType
//		{
//			CARTESIAN_COORDS, 
//			POLAR_COORDS,
//			POLAR_COORDS_WITH_POLYNOMIAL,
//			REAL_SPACE_EXACT_S1,
//			REAL_SPACE_NORMALIZED_EXACT_S1
//		};
//	
//		struct PointDistributionParams
//		{
//			PointDistributionParams();
//			bool m_bPointDistrSpeedup;
//			bool m_bSumGaussians;
//			int m_iPointDistrDimX;
//			int m_iPointDistrDimY;
//			int m_PointDistrPolyPower;
//			IntegrationApproximationType m_IntegrationType;
//			double m_fPoissonDisk;
//			PDSampler * m_pPointSampler;			
//		};	
//	
//		struct Vertex
//		{
//			double pos[3];
//			//std::vector<int> edges;
//		};
//	
//		struct Edge
//		{
//			int vert[2];
//		};
//
//		/** Random point splatting: enhanced Mitchell's 1991 algorithm*/
//		DeformCurve(int numBestEnergy, int numFarthest, int numPnts, int imWidth, int imHeight, 
//					double stdDev=-1, bool bApprox=true, 
//					PointDistributionParams pntsParams = PointDistributionParams());
//	
//		//bApprox - approximate function calculation to non-smooth distances
//		DeformCurve(QString curveFile, double paramStep, int imWidth=-1, int imHeight=-1, 
//					double stdDev=-1, bool bApprox=true, 
//					PointDistributionParams pntsParams = PointDistributionParams());
//		DeformCurve(std::vector<Vertex *> &vertices, double paramStep, int imWidth=-1, int imHeight=-1,
//					double stdDev=-1, bool bApprox=true, bool separatePoints = false, 
//					PointDistributionParams pntsParams = PointDistributionParams());	//initialized closed curve
//		DeformCurve(std::vector<Vertex *> &vertices, std::vector<Edge *> &edges, 
//					std::vector<Vertex*> &individualVertices, double paramStep, 
//					int imWidth=-1, int imHeight=-1, double stdDev=-1, bool bApprox=true,
//					PointDistributionParams pntsParams = PointDistributionParams());//arbitrary curve
//		DeformCurve(QString simpleShape, double * params, double paramStep, 
//					int imWidth=-1, int imHeight=-1, double stdDev=-1, bool bApprox=true,
//					PointDistributionParams pntsParams = PointDistributionParams());
//	
//		void InitClosedCurve(std::vector<Vertex *> &vertices, double paramStep, 
//							 int imWidth, int imHeight, double stdDev, bool bApprox);
//												//closed curve (fixed topology)
//		void InitCurve(std::vector<Vertex *> &vertices, std::vector<Edge *> &edges, 
//					   std::vector<Vertex *> &individualVertices, double paramStep, 
//					   int imWidth, int imHeight, double stdDev, bool bApprox, 
//					   double expandScreenX, double expandScreenY,
//					   PointDistributionParams pntsParams = PointDistributionParams());		//arbitrary curve
//		void InitCurveShape(QString shape, double * params, double paramStep, 
//							int imWidth, int imHeight, double stdDev, bool bApprox,
//							PointDistributionParams pntsParams);
//		void WriteCurve(QString curveFile);
//	
//		void AssignVertices(SymVectorReal &params, double * outPenalty);
//	
//		virtual SymMatrix & Deform(SymVectorReal & params, double * outPenalty = NULL);
//		void SaveImages(QString prefixes, int numU, int numV);
//
//		virtual SymMatrix & TakeStepInDimension(int dimension, double dx, double & penalty);
//		virtual void RevertLastStepInDimension();
//	
//		SymMatrix & GetL2PointsEnergy(SymVectorReal & params, double * outPenalty = NULL);
//		void InitFastPointsDistr(double sigma, int N);
//		void GetSamplingRadii(std::vector<double> &radii, int Nr, int K, double Rmax, double sigma);
//		PointDistributionParams m_PointDistrParams;
//		double GetIIx(double xi, double xj, double sigma);
//	
//		struct FastPntDistrEntry
//		{
//			FastPntDistrEntry(double u, double v, double w, double A2)
//			{
//				this->u = u;	this->v = v;
//				this->w = w;	this->A2 = A2;				
//			};
//			double u;
//			double v;
//			double w;	// integration weight
//			double A2;	// A(u,v)
//			double B_imaginary;
//			double B_real;
//		};
//		std::vector<FastPntDistrEntry> m_FastPntUV;
//		std::vector<double> m_UniformU;
//		std::vector<double> m_UniformV;	
//		double m_fL2S;
//		double m_fL2f;
//		
//		virtual ~DeformCurve(){}
//		virtual bool HasOutput(OutputType type);
//		virtual QImage GetDeformedImage(int imageType = 0);
//		void GetCenterOfMass(double * cx, double * cy);
//		void GetOutputDimensions(int * inWidth, int * inHeight);
//	
//		virtual int GetNumOutputImageTypes();
//	
//		virtual SymMatrix & TakeRandomStep(bool & enforceStep);
//		virtual void RevertLastRandomStep();
//		virtual bool TerminalState();
//		
//		static void ConvertPointCloudToClosedCurve(QString inFile, QString outFile);
//		static void TestCurve();
//		static QString GetPointsDescriptor(double dx, double dy, int numX, int numY, int numAdditional, 
//										   double highFreqNoise, double lowFreqNoise, double probMissing,
//										   int randomSeed);
//		
//		int m, n;
//	
//		SymMatrix2DReal & GetGaussianSplat(double stdDev);
//		QMap<double, SymMatrix2DReal *> m_StdDevToGaussianSplat;
//		void ToroidalShiftPnt(double x, double y, double * newX, double * newY);
//		void AddGaussian(SymMatrix2DReal & trgMatrix, double cx, double cy, double sign);
//		int m_iMitchelPoissonNumFarthest;
//		int m_iMitchelPoissonNumBestEnergy;
//		int m_NMaxPnts;
//		std::vector<double> m_FarthestPointsCandidates;
//		std::vector<int> m_ExaminedCandidateList;
//		int m_iCurrCandidate;
//		int m_iAddingPointID;
//		bool m_bDartThrowing;
//	
////	protected:
//	
//		SymMatrix2DReal * m_pSingleValue;
//	
//		double m_fForegroundColor;
//		double m_fLineWidth;
//		bool m_bApproximate;
//		double m_fScaleX;
//		double m_fScaleY;
//		int m_ScreenWidth;
//		int m_ScreenHeight;
//		R3Point m_Origin;
//		R3Point m_MaxPnt;
//		double m_fStdDev;	
//	
//		std::vector<Vertex *> m_Vertices;
//		std::vector<Edge *> m_Edges;
//		std::vector<int> m_RenderableVertices;
//		
//		R2Grid * m_pDistanceGrid;
//		QGLPixelBuffer * s_pFramebuffer;
//		QImage m_DeformedImage;
//		bool m_bInitedWorldFrame;
//};
//
//
//#endif
//
