#include "Numerical.h"
#include "SymSpace.h"
#include "TimeProfiler.h"

#ifndef __SYM_ENERGY_H
#define __SYM_ENERGY_H

class SymEnergy
{
	public:
		SymEnergy(SymSpace * S){m_pS = S;}
		virtual ~SymEnergy(){}
		virtual double GetEnergy(SymMatrix & f) = 0;
		virtual SymSpace * GetUnderlyingSymmetrySpace(){ return m_pS;}
	
		SymSpace * m_pS;
};

class SymEnergyDifference : public SymEnergy
{
	public:
		SymEnergyDifference(SymSpace * S, double p, SymMatrix2DReal & g);
		virtual ~SymEnergyDifference();	
		virtual double GetEnergy(SymMatrix & f);	
	
		SymMatrix2DReal * m_pTargetSymmetry;
		double p;
};

class SymEnergySymmetrization : public SymEnergy
{
	public:
		SymEnergySymmetrization(SymSpace * S, QString energyType, bool assymmetrization = false, double p = 1);	
		virtual ~SymEnergySymmetrization();
		virtual double PeakinessL2OverL1(SymMatrix & Sf);
		virtual double PeakinessL2OverL1With1InNom(SymMatrix & Sf);
		virtual double SumSquaresToMean(SymMatrix & Sf);
		virtual double SumGradients(SymMatrix & Sf, int dim);
		virtual double SumEdges(SymMatrix & Sf);
		virtual double GetEnergy(SymMatrix & f);
		QString m_sEnergyType;
		double m_fSign;
		double m_fP;
};

#endif